from django.db import models
from clmainApp.models import User
#from mainApp.utils import *
from clmainApp.models import *
from clbranchApp.models import Branch
from brmainApp.models import Location
from django.utils.translation import gettext as _
#from clbranchApp.models import ClinicTypeComplaint,Branch
#from entagencyApp.models import TVChannel,TVProgram
# from django.db.models.signals import post_save
# from django.dispatch import receiver
import uuid

# Create your models here.
############## Patient%Module #################
BLOOD_TYPE_CHOICES=(
    (0, "غير محدد"),
    #(9, "Rh +ve"),
    #(10,"Rh -ve"),
    (1, "A+"),
    (2, "A-"),
    (3, "B+"),
    (4, "B-"),
    (5, "AB+"),
    (6, "AB-"),
    (7, "O+"),
    (8, "O-"),
)
SMOKING_STATUS_CHOICES=(
    (0, "غير محدد"),
    (1, "غير مدخن"),
    (2, "مدخن سابق"),
    (3, "مدخن حالي"),
)

MARKETING_CODE_CHOICES = (
    ('NEW_PT', "مريض جديد"), # New Patient
    ('V_NO_S', " كشف بدون جلسات"),# Visit no session
    ('V_W_S', "كشف منتظر جلسات"),# Visit wait session هيبدأ بعدين لكن اتشخص انه المفروض يعمل جلسات 
    ('V_S_S', "كشف بدأ جلسات"),# Visit start session 
    ('NT_ELG', "غير مؤهل للعلاج"),# Not eligible for treatment
    ('OTHER', "أخرى"),# أى حاجه تانية هنكتب فى ملاحظات الدكتور - او ملاحظات الاستقبال    
    ('CANCEL', "إلغاء"), # New Patient
)
# def add_one():
#     #الأكواد هتكون طبقا هو تبع فرع إيه 
#     #لما أنقل مريض من فرع لفرع هياخد كود جديد فى الفرع الجديد 
#     largest = Patient.objects.vlaues('code').order_by('code').last()

#     #largest = Patient.objects.filter() Complaint.objects.vlaues('code').order_by('code').last()
#     if not largest:
#         # largest is `None` if `YourModel` has no instances
#         # in which case we return the start value of 10
#         #return 10
#         return 1
#     # If an instance of `YourModel` is returned, we get it's
#     # `tens` attribute and increment it by 10
#     #return largest.tens + 10
#     return largest["code"] + 1

class Patient(models.Model):
    branch = models.ForeignKey(Branch,on_delete=models.PROTECT)   
    fullname =  models.CharField(max_length=250,blank=True, null=True,help_text = "patient_name" , verbose_name ="name")
    rfid = models.CharField(max_length=50,blank=True,null=True)
    code = models.IntegerField(blank=True,null=True)
    number_1 = models.CharField(max_length=20)
    number_2 = models.CharField(max_length=20, blank=True,null=True)
    #complaint = models.ForeignKey(Complaint,on_delete=models.PROTECT)
    #nationality = models.ForeignKey(Nationality,on_delete=models.PROTECT)
    location = models.ForeignKey(Location,on_delete=models.PROTECT)
    #clinic = models.ForeignKey(Clinic,on_delete=models.PROTECT)   
    foundway = models.ForeignKey(FoundWay,on_delete=models.PROTECT,blank=True,null=True)
    #channel = models.ForeignKey(TVChannel,on_delete=models.PROTECT,blank=True,null=True)
    #program = models.ForeignKey(TVProgram,on_delete=models.PROTECT,blank=True,null=True)
    birth_date = models.DateField(blank=True,null=True)
    #address = models.CharField(max_length=100, blank=True,null=True)
    #balance = models.IntegerField(default=0)
    last_visit = models.DateTimeField(blank=True,null=True)
    next_consult = models.DateField(blank=True,null=True)
    is_male = models.BooleanField(
        _('is_male'),
        default=True,
        help_text=_(
            'Unselect if gender is female'
        ),
    )
    is_active = models.BooleanField(default=True,help_text='Unselect this instead of deleting Patients.')
    dr_notes = models.CharField(max_length=150, blank=True,null=True)
    rcp_notes = models.CharField(max_length=150, blank=True,null=True)
    #notes = models.CharField(max_length=150, blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(auto_now_add=True)
    is_blocked = models.BooleanField(default=False)
    is_wa_policy_sent = models.BooleanField(default=False)
    def __str__(self):
        return str(self.fullname)
    class Meta:
        unique_together = (("branch", "fullname"),("branch","number_1"))

class PatientBlock(models.Model):
    patient =  models.ForeignKey(Patient,related_name="PatientBlock_patient",on_delete=models.PROTECT,)                      
    block_notes = models.CharField(max_length=100)
    blocked_by = models.ForeignKey(User,on_delete=models.PROTECT,related_name="PatientBlock_blocked_by",)
    blocked_at = models.DateTimeField(auto_now_add=True)
    unblocked_by = models.ForeignKey(User,on_delete=models.PROTECT,related_name="PatientBlock_unblocked_by",)
    unblocked_at = models.DateTimeField(auto_now_add=True)
    unblock_notes = models.CharField(max_length=100, blank=True,null=True)

    def __str__(self):
        return str(self.patient.fullname)

#https://www.medicakare.com/sys/medicakare/medical_report.php?st_id=150538
DIFFICULTY_CHOICES=(
    (0, "UnDefined"),
    (1, "Easy"),
    (2, "Moderate"),
    (3, "Difficult"),
)

MECHANICAL_ASSESSMENT_CHOICES=(
    (0, "UnDefined"),
    (1, "Anterior Pelvic Tilt"),
    (2, "Post Pelvic Tilt"),
    (3, "Flat Cervical Curve"),
    (4, "Upper Cross Syndrome"),
    (5, "Lat Pelvic Tilt"),
    (6, "Supraspinatus Tendenitis"),
    (7, "Scoliosis"),
    (8, "Knee Arthritis"),
    (9, "Knee Meniscus"),
    (10, "Frozen Shoulder"),
)

TP_RELEASE_CHOICES=(
    (0, "UnDefined"),
    (1, "upper trap scalenes pecs erctor spine"),
    (2, "calf ,hamstring ,pirformis ,quadratus ,erctorspine "),
    #(3, "CHOICE 3"),
)
TP_STRETCH_CHOICES=(
    (0, "UnDefined"),
    (1, "hamstring , scalenes"),
    (2, "hamstring , pirformis"),
    #(3, "CHOICE 3"),
)
TP_STRENGTH_CHOICES=(
    (0, "UnDefined"),
    (1, "G.med ,G.max,multifidus"),
    (2, "G.max , lower trap, serratus, c.ext, nags"),
    #(3, "CHOICE 3"),
)
class PatientInfo(models.Model):
    patient =  models.OneToOneField(
        Patient,
        related_name="patient_info",
        on_delete=models.PROTECT,
    )
    last_visit = models.DateTimeField(blank=True,null=True)
    last_session = models.DateTimeField(blank=True,null=True)
    pt_status = models.ForeignKey(PatientStatus,on_delete=models.PROTECT,blank=True,null=True)
    marketing_code = models.CharField(choices=MARKETING_CODE_CHOICES ,max_length=10, default="NEW_PT")
    onset_date = models.DateField(blank=True, null=True)#تاريخ الاصابة
    is_cervical = models.BooleanField(default=False)
    is_lumbar = models.BooleanField(default=False)
    is_knee = models.BooleanField(default=False)
    is_shoulder = models.BooleanField(default=False)
    difficulty = models.IntegerField(choices=DIFFICULTY_CHOICES , default=0)
    slr = models.IntegerField(blank=True, null=True)#min 1 max 90
    no_of_sessions = models.CharField(max_length=10,blank=True, null=True)
    mechanism_of_injury = models.CharField(max_length=150, blank=True,null=True)
    mechanical_assessment = models.IntegerField(choices=MECHANICAL_ASSESSMENT_CHOICES , default=0)
    tp_release = models.IntegerField(choices=TP_RELEASE_CHOICES , default=0)
    tp_stretch = models.IntegerField(choices=TP_STRETCH_CHOICES , default=0)
    tp_strength = models.IntegerField(choices=TP_STRENGTH_CHOICES , default=0)
    tp_release_notes = models.CharField(max_length=150, blank=True,null=True)#Treatment Plan release stretch strength
    tp_stretch_notes = models.CharField(max_length=150, blank=True,null=True)
    tp_strength_notes = models.CharField(max_length=150, blank=True,null=True)

    chronic_diseases = models.TextField(blank=True, null=True)#  الأمراض المزمنة
    genetic_diseases = models.TextField(blank=True, null=True)#  الأمراض الوراثية
    surgical_history = models.TextField(blank=True, null=True)#العمليات  الجراحية
    allergies_history =  models.TextField(blank=True, null=True)#   تاريخ الحساسية
    family_history =  models.TextField(blank=True, null=True)#   التاريخ المرضى للعائلة 
    diagnosis = models.TextField(blank=True, null=True)#التشخيص

    visit_6_notes = models.TextField(blank=True, null=True)
    visit_7_notes = models.TextField(blank=True, null=True)
    
    smoking_status = models.IntegerField(choices=SMOKING_STATUS_CHOICES , default=0)
    blood_type = models.IntegerField(choices=BLOOD_TYPE_CHOICES , default=0) 
    notes = models.TextField(blank=True, null=True)
    last_update_by = models.ForeignKey(User,on_delete=models.PROTECT)
    last_update_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return str(self.patient.fullname)

def pa_file_url(instance, filename):
    ext = filename.split('.')[-1]
    return "%s/%s/%s" % ("Patients",instance.patient.id, "{}.{}".format(uuid.uuid4(), ext))


PA_TYPE_CHOICES=(
    ("U","غير محدد"), # Undefined
    ("T", "تحليل"),   #Test
    ("R", "اشعة"),  # Ray
    ("O", "عملية"),  # Operation
    ("S", "جراحة"),  # Surgery
)
class PtAttachment(models.Model):
    patient =  models.ForeignKey(
        Patient,
        related_name="PtAttachment_patient",
        on_delete=models.PROTECT,
    )
    pa_label = models.CharField(max_length=250, blank=True,null=True)
    pa_file = models.FileField(upload_to=pa_file_url, null=True, blank=True)
    description = models.TextField(blank=True, null=True)
    doctor_notes = models.TextField(blank=True, null=True)
    created_by = models.ForeignKey(User,on_delete=models.DO_NOTHING)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return "{}-{}".format(self.patient.fullname,str(self.created_at))
    
def extra_pa_file_url(instance, filename):
    ext = filename.split('.')[-1]
    return "%s/%s/%s" % ("Patients",instance.pt_attachment.patient.id, "{}.{}".format(uuid.uuid4(), ext))
class ExtraPtAttachment(models.Model):
    pt_attachment = models.ForeignKey(PtAttachment,on_delete=models.PROTECT)
    image = models.FileField(upload_to=extra_pa_file_url,)
    def __str__(self) -> str:
        return f"{self.pt_attachment}"
    
class IrregularPtData(models.Model):
    patient =  models.OneToOneField(
        Patient,
        related_name="IrregularPtInfo_patient",
        on_delete=models.PROTECT,
    )

    br_notes = models.CharField(max_length=100, blank=True,null=True)#ملاحظات عدم الانتظام للفرع 
    br_created_by = models.ForeignKey(User,on_delete=models.PROTECT,related_name="IrregularPtData_br_created_by",blank=True,null=True)
    br_created_at = models.DateTimeField(blank=True,null=True)

    cl_notes = models.CharField(max_length=100, blank=True,null=True)#ملاحظات عدم الانتظام للمركز 
    cl_created_by = models.ForeignKey(User,on_delete=models.PROTECT,related_name="IrregularPtData_cl_created_by",blank=True,null=True)
    cl_created_at = models.DateTimeField(blank=True,null=True)

    is_hidden = models.BooleanField(default=False)
    def __str__(self):
        return "{}-{}".format(self.patient.fullname,str(self.is_hidden))
    
class PtEvaluationCard(models.Model):
    patient =  models.ForeignKey(
        Patient,
        related_name="PtEvaluationCard_patient",
        on_delete=models.PROTECT,
    )
    progress = models.CharField(max_length=250, blank=True,null=True)
    problems  = models.CharField(max_length=250, blank=True,null=True)
    objectives  = models.CharField(max_length=250, blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.DO_NOTHING)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return "{}-{}".format(self.patient.fullname,str(self.created_at))

class PtRomAssessment(models.Model):
    patient =  models.ForeignKey(
        Patient,
        related_name="PtRomAssessment_patient",
        on_delete=models.PROTECT,
    )
    visit_day = models.DateField(blank=True,null=True)
    #Cervical
    c_extension = models.IntegerField(blank=True,null=True)
    c_flextion = models.IntegerField(blank=True,null=True)
    c_lt_rotation = models.IntegerField(blank=True,null=True)
    c_rt_rotation = models.IntegerField(blank=True,null=True)
    c_lt_side_bending = models.IntegerField(blank=True,null=True)
    c_rt_side_bending = models.IntegerField(blank=True,null=True)
    #Lumbar   
    l_extension = models.IntegerField(blank=True,null=True)
    l_flextion = models.IntegerField(blank=True,null=True)
    l_lt_rotation = models.IntegerField(blank=True,null=True)
    l_rt_rotation = models.IntegerField(blank=True,null=True)
    l_lt_side_bending = models.IntegerField(blank=True,null=True)
    l_rt_side_bending = models.IntegerField(blank=True,null=True)
    #End Lumbar
    notes = models.CharField(max_length=200,blank=True, null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return str(self.patient.fullname)

'''
class PatientExternalPayment(models.Model):
    patient =  models.ForeignKey(
        Patient,
        related_name="PatientExternalPayment_patient",
        blank=True,
        null=True,
        on_delete=models.PROTECT,
    )
    amount_paid = models.IntegerField(default=0,help_text = "سداد ديون - دفع مبلغ مقدم ")
    notes = models.CharField(max_length=150,blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(auto_now_add=True)
    def __str__(self):
        return "{}-{}".format(self.patient.fullname,self.amount_paid)

class PatientWithdrawal(models.Model):
    patient =  models.ForeignKey(
        Patient,
        related_name="PatientWithdrawal_patient",
        blank=True,
        null=True,
        on_delete=models.PROTECT,
    )
    amount_taken = models.IntegerField(default=0,help_text = "سداد ديون - دفع مبلغ مقدم ")
    notes = models.CharField(max_length=150,blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(auto_now_add=True)
    def __str__(self):
        return "{}-{}".format(self.patient.fullname,self.amount_taken)
'''
############## END Patient%Module #################